;	================================================================================
							.Code
;	================================================================================


							ALIGN	4

;	================================================================================

Effects_WmPaint				PROC	USES EBX EDI ESI
							LOCAL	_Ps:PAINTSTRUCT
							LOCAL	_hDC:HDC

							lea		eax,_Ps

							push	eax
							push	esi

							INVOKE	BeginPaint,esi,eax 

							mov		_hDC,eax

@Exit :

							call	EndPaint

							ret
Effects_WmPaint				ENDP

;	================================================================================

Effects_WmCreate			PROC	USES EBX EDI ESI
							LOCAL	_rc:RECT

							INVOKE	GetClientRect,esi,ADDR _rc

							INVOKE	CreateWindowEx,NULL,ADDR szComboBox,ADDR szNullString,\
									CBS_DROPDOWNLIST or CBS_HASSTRINGS or CBS_SORT or WS_CHILD or WS_VISIBLE,\
									0,0,_rc.right,300,esi,1999h,hInstance,NULL

							mov		hComboEffects,eax

							INVOKE	SendMessage,eax,WM_SETFONT,hMainFont,TRUE

							INVOKE	SendMessage,hComboEffects,CB_ADDSTRING,0,ADDR szRgb
							INVOKE	SendMessage,hComboEffects,CB_SETITEMDATA,0,0
							INVOKE	SendMessage,hComboEffects,CB_SETCURSEL,0,0

							ret
Effects_WmCreate			ENDP

;	================================================================================

Effects_WmClose				PROC	USES EBX EDI ESI
							ret
Effects_WmClose				ENDP

;	================================================================================

Effects_WmSize				PROC	USES EBX EDI ESI,_dwNewWidth:DWord,_dwNewHeight:DWord

							INVOKE	MoveWindow,hComboEffects,0,0,_dwNewWidth,_dwNewHeight,TRUE

							ret
Effects_WmSize				ENDP

;	================================================================================

Effects_WmNotify			PROC	USES EBX EDI ESI
							ret
Effects_WmNotify			ENDP

;	================================================================================

Effects_WmCommand			PROC	USES EBX EDI ESI
							ret
Effects_WmCommand			ENDP

;	================================================================================

EffectsWndProc				PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

							mov		esi,DWord Ptr hWnd
							mov		edi,DWord Ptr lParam
							mov		ebx,DWord Ptr wParam
							mov		eax,DWord Ptr uMsg

							cmp		eax,WM_PAINT
							jne		@F

								push	OFFSET @Exit
								jmp		Effects_WmPaint

@@ :

							cmp		eax,WM_CREATE
							jne		@F

								push	OFFSET @End
								jmp		Effects_WmCreate

@@ :

							cmp		eax,WM_CLOSE
							jne		@F

								push	OFFSET @End
								jmp		Effects_WmClose

@@ :

							cmp		eax,WM_SIZE
							jne		@F

								mov		eax,edi
								and		eax,0000ffffh
								shr		edi,16

								push	edi
								push	eax
								push	OFFSET @Exit
								jmp		Effects_WmSize

@@ :

							cmp		eax,WM_NOTIFY
							jne		@F

								push	OFFSET @Exit
								jmp		Effects_WmNotify

@@ :

							cmp		eax,WM_COMMAND
							jne		@F

								movzx	eax,Word Ptr wParam + 2
								push	eax
								movzx	eax,Word Ptr wParam
								push	eax
								push	OFFSET @End
								jmp		Effects_WmCommand

@@ :

							push	edi
							push	ebx
							push	eax
							push	esi
							push	OFFSET @End
							jmp		DefWindowProc							

@Exit :

							xor		eax,eax

@End :

							ret
EffectsWndProc				ENDP

;	================================================================================

Effects_Create :

							INVOKE	CreateWindowEx,WS_EX_CLIENTEDGE or WS_EX_WINDOWEDGE or WS_EX_STATICEDGE or WS_EX_TOOLWINDOW,\
									ADDR szEffectsClass,ADDR szEffectsName,WS_CAPTION or WS_CHILD or WS_VISIBLE,\
									rcEffects.left,rcEffects.top,rcEffects.right,rcEffects.bottom,\
									esi,1902h,hInstance,NULL

							push	eax

							push	eax

							push	SW_SHOW
							push	eax
							call	ShowWindow
							call	UpdateWindow

							pop		eax

							ret

;	================================================================================
