;	================================================================================
							.Code
;	================================================================================

							ALIGN	4

;	================================================================================

ThreadNextFoldersProc		PROC	USES EBX EDI ESI,_lpTvFolders:Ptr TV_FOLDERS
							LOCAL	_TVis:TV_INSERTSTRUCT
							LOCAL	_Wf:WIN32_FIND_DATA
							LOCAL	_szOldDirectory[MAX_PATH]:Byte
							LOCAL	_szNewDirectory[MAX_PATH]:Byte

							mov		edi,_lpTvFolders

							mov		eax,(TV_FOLDERS Ptr [edi]).hThreadParent
							mov		_TVis.hParent,eax
							mov		_TVis.hInsertAfter,TVI_SORT
							mov		_TVis.itemex.imask,TVIF_DI_SETITEM or TVIF_PARAM or TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
							mov		_TVis.itemex.cChildren,1
							mov		_TVis.itemex.iImage,19
							mov		_TVis.itemex.iSelectedImage,18
							mov		eax,(TV_FOLDERS Ptr [edi]).dwThreadIndex
							mov		_TVis.itemex.lParam,eax
							lea		eax,_Wf.cFileName
							mov		_TVis.itemex.pszText,eax

							INVOKE	GetCurrentDirectory,MAX_PATH,ADDR _szOldDirectory
							INVOKE	SetCurrentDirectory,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName

							test	eax,eax
							jz		@Exit

							INVOKE	FindFirstFile,ADDR szAllFiles,ADDR _Wf

							cmp		eax,INVALID_HANDLE_VALUE
							je		@Exit

							mov		esi,eax

							and		_Wf.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
							jz		@Next

							cmp		Byte Ptr _Wf.cFileName,'.'
							je		@Next

							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_FOUND,ADDR _Wf,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName
							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis
							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_ADDED,eax,NULL

@Next :

							INVOKE	FindNextFile,esi,ADDR _Wf

							test	eax,eax
							jz		@EndLoop

							cmp		Byte Ptr _Wf.cFileName,'.'
							je		@Next

							and		_Wf.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
							jz		@Next

							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_FOUND,ADDR _Wf,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName
							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							push	NULL
							push	eax
							push	WM_IVIEW_FOLDER_ADDED
							push	hWndMain
							push	OFFSET @Next
							jmp		SendMessage

@EndLoop :

							INVOKE	FindClose,esi
							INVOKE	SendMessage,hTreeView,TVM_EXPAND,TVE_EXPAND,(TV_FOLDERS Ptr [edi]).hThreadParent
							INVOKE	SetCurrentDirectory,ADDR _szOldDirectory

@Exit :

							ret
ThreadNextFoldersProc		ENDP

;	================================================================================

ThreadFirstFoldersProc		PROC	USES EBX EDI ESI,_lpTvFolders:Ptr TV_FOLDERS
							LOCAL	_TVis:TV_INSERTSTRUCT
							LOCAL	_Wf:WIN32_FIND_DATA
							LOCAL	_szOldDirectory[MAX_PATH]:Byte
							LOCAL	_szNewDirectory[MAX_PATH]:Byte

							mov		edi,_lpTvFolders

							mov		eax,(TV_FOLDERS Ptr [edi]).hThreadParent
							mov		_TVis.hParent,eax
							mov		_TVis.hInsertAfter,TVI_SORT
							mov		_TVis.itemex.imask,TVIF_DI_SETITEM or TVIF_PARAM or TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
							mov		_TVis.itemex.cChildren,1
							mov		_TVis.itemex.iImage,19
							mov		_TVis.itemex.iSelectedImage,18
							mov		_TVis.itemex.lParam,2
							lea		eax,_Wf.cFileName
							mov		_TVis.itemex.pszText,eax

							INVOKE	GetCurrentDirectory,MAX_PATH,ADDR _szOldDirectory
							INVOKE	SetCurrentDirectory,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName

							test	eax,eax
							jz		@Exit

							INVOKE	FindFirstFile,ADDR szAllFiles,ADDR _Wf

							cmp		eax,INVALID_HANDLE_VALUE
							je		@Exit

							mov		esi,eax

							cmp		Byte Ptr _Wf.cFileName,'.'
							je		@Next

							and		_Wf.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
							jz		@Next

							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_FOUND,ADDR _Wf,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName
							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis
							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_ADDED,eax,NULL

@Next :

							INVOKE	FindNextFile,esi,ADDR _Wf

							test	eax,eax
							jz		@EndLoop

							cmp		Byte Ptr _Wf.cFileName,'.'
							je		@Next

							and		_Wf.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
							jz		@Next

							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_FOUND,ADDR _Wf,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName
							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							push	NULL
							push	eax
							push	WM_IVIEW_FOLDER_ADDED
							push	hWndMain
							push	OFFSET @Next
							jmp		SendMessage

@EndLoop :

							INVOKE	FindClose,esi
							INVOKE	SendMessage,hTreeView,TVM_EXPAND,TVE_EXPAND,(TV_FOLDERS Ptr [edi]).hThreadParent
							INVOKE	SetCurrentDirectory,ADDR _szOldDirectory

@Exit :

							ret
ThreadFirstFoldersProc		ENDP

;	================================================================================

ThreadFoldersProc			PROC	USES EBX EDI ESI,_lpTvFolders:Ptr TV_FOLDERS
							LOCAL	_TVis:TV_INSERTSTRUCT
							LOCAL	_Wf:WIN32_FIND_DATA
							LOCAL	_szOldDirectory[MAX_PATH]:Byte
							LOCAL	_szNewDirectory[MAX_PATH]:Byte

							mov		edi,_lpTvFolders

							mov		eax,(TV_FOLDERS Ptr [edi]).hItem
							mov		_TVis.hParent,eax
							mov		_TVis.hInsertAfter,TVI_SORT
							mov		_TVis.itemex.imask,TVIF_DI_SETITEM or TVIF_PARAM or TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
							mov		_TVis.itemex.cChildren,1
							mov		_TVis.itemex.iImage,19
							mov		_TVis.itemex.iSelectedImage,18
							mov		_TVis.itemex.lParam,1
							lea		eax,_Wf.cFileName
							mov		_TVis.itemex.pszText,eax

							INVOKE	GetCurrentDirectory,MAX_PATH,ADDR _szOldDirectory
							INVOKE	SetCurrentDirectory,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName

							test	eax,eax
							jz		@Exit

							INVOKE	FindFirstFile,ADDR szAllFiles,ADDR _Wf

							cmp		eax,INVALID_HANDLE_VALUE
							je		@Exit

							mov		esi,eax

							cmp		Byte Ptr _Wf.cFileName,'.'
							je		@Next

							and		_Wf.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
							jz		@Next

							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_FOUND,ADDR _Wf,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName
							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis
							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_ADDED,eax,NULL

@Next :

							INVOKE	FindNextFile,esi,ADDR _Wf

							test	eax,eax
							jz		@EndLoop

							cmp		Byte Ptr _Wf.cFileName,'.'
							je		@Next

							and		_Wf.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
							jz		@Next

							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_FOUND,ADDR _Wf,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName
							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							push	NULL
							push	eax
							push	WM_IVIEW_FOLDER_ADDED
							push	hWndMain
							push	OFFSET @Next
							jmp		SendMessage

@EndLoop :

							INVOKE	FindClose,esi
							INVOKE	SendMessage,hTreeView,TVM_EXPAND,TVE_EXPAND,(TV_FOLDERS Ptr [edi]).hItem
							INVOKE	SetCurrentDirectory,ADDR _szOldDirectory

@Exit :

							ret
ThreadFoldersProc			ENDP

;	================================================================================

Folders_WmPaint				PROC	USES EBX EDI ESI
							LOCAL	_Ps:PAINTSTRUCT
							LOCAL	_hDC:HDC

							lea		eax,_Ps

							push	eax
							push	esi

							INVOKE	BeginPaint,esi,eax 

							mov		_hDC,eax

@Exit :

							call	EndPaint

							ret
Folders_WmPaint				ENDP

;	================================================================================

CreateTreeView				PROC	USES EBX EDI ESI
							LOCAL	_rc:RECT

							INVOKE	GetClientRect,esi,ADDR _rc

							push	NULL
							push	DWord Ptr hInstance
							push	1959h
							push	esi							; Parent
							push	DWord Ptr _rc.bottom		; H
							push	DWord Ptr _rc.right			; W
							push	0							; Y
							push	0							; X
							push	WS_HSCROLL or WS_BORDER or WS_CHILD or WS_VISIBLE or TVS_HASLINES or TVS_HASBUTTONS or TVS_LINESATROOT or TVS_EDITLABELS or TVS_FULLROWSELECT or TVS_INFOTIP or TVS_SHOWSELALWAYS or WS_CLIPSIBLINGS
							push	OFFSET szNullString
							push	OFFSET szTreeClass
							push	WS_EX_CLIENTEDGE
							call	CreateWindowEx

							mov		DWord Ptr hTreeView,eax 

							INVOKE	SendMessage,hTreeView,WM_SETFONT,hMainFont,TRUE

							INVOKE	SendMessage,hTreeView,TVM_SETBKCOLOR,0,00ffffffh			;	00e1f0ffh
							INVOKE	SendMessage,hTreeView,TVM_SETTEXTCOLOR,0,0					;	00ffffe0h
							INVOKE	SendMessage,hTreeView,TVM_SETLINECOLOR,0,00ff00ffh					;	00ffffe0h
							INVOKE	SendMessage,hTreeView,TVM_SETINSERTMARKCOLOR,0,00ffffe0h

							INVOKE	ImageList_Create,16,16,ILC_COLOR32,18,10

							mov		DWord Ptr hImageList,eax
							push	eax

							INVOKE	LoadBitmap,hInstance,IDB_BO16_01

							push	eax

							INVOKE	ImageList_Add,hImageList,eax,NULL

							call	DeleteObject

							push	0
							push	TVM_SETIMAGELIST
							push	DWord Ptr hTreeView
							call	SendMessage

@Exit :

							ret
CreateTreeView				ENDP

;	================================================================================

Folders_WmCreate			PROC	USES EBX EDI ESI
							LOCAL	_TVis:TV_INSERTSTRUCT
							LOCAL	_Tvi:TVITEM
							LOCAL	_hParent:HTREEITEM
							LOCAL	_hComputer:HTREEITEM
							LOCAL	_dwDrive:DWord
							LOCAL	_dwTmp:DWord
							LOCAL	_szTmp[512]:Byte

							call	CreateTreeView

							INVOKE	SHGetSpecialFolderPath,NULL,ADDR szDesktop,CSIDL_DESKTOPDIRECTORY,FALSE
							INVOKE	SHGetSpecialFolderPath,NULL,ADDR szMyDocuments,CSIDL_PERSONAL,FALSE
							INVOKE	SHGetSpecialFolderPath,NULL,ADDR szMyImages,CSIDL_MYPICTURES,FALSE
							INVOKE	SHGetSpecialFolderPath,NULL,ADDR szMyMusique,CSIDL_MYMUSIC,FALSE
							INVOKE	SHGetSpecialFolderPath,NULL,ADDR szMyVideos,CSIDL_MYVIDEO,FALSE

;	**************
;	*** Bureau ***
;	**************

							INVOKE	Memory_Alloc,SIZEOF TV_FOLDERS

							mov		edi,eax
							mov		lpBureau,eax

							mov		_TVis.itemex.lParam,eax

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [eax]).szDirectoryName,ADDR szDesktop

							mov		_TVis.hParent,TVI_ROOT
							mov		_TVis.hInsertAfter,TVI_FIRST
							mov		_TVis.itemex.imask,TVIF_DI_SETITEM or TVIF_PARAM or TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
							mov		_TVis.itemex.pszText,OFFSET szBureau
							mov		_TVis.itemex.cChildren,1
							mov		_TVis.itemex.iImage,0
							mov		_TVis.itemex.iSelectedImage,0

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		_hParent,eax
							mov		_TVis.hParent,eax

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

;	************************
;	*** Poste de Travail ***
;	************************

							INVOKE	Memory_Alloc,SIZEOF TV_FOLDERS

							mov		edi,eax
							mov		lpPosteDeTravail,eax

							mov		_TVis.itemex.lParam,eax
							mov 	(TV_FOLDERS Ptr [eax]).szDirectoryName,-1

							mov		edx,_hParent
							mov		(TV_FOLDERS Ptr [eax]).hParent,edx
							mov		(TV_FOLDERS Ptr [eax]).dwType,-1
							mov		(TV_FOLDERS Ptr [eax]).dwIndex,0

							mov		_TVis.hInsertAfter,TVI_SORT
							mov		_TVis.itemex.pszText,OFFSET szPosteDeTravail
							mov		_TVis.itemex.iImage,1
							mov		_TVis.itemex.iSelectedImage,1

							mov		_TVis.itemex.lParam,OFFSET szMyComputer

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

							mov		_hComputer,eax

;	*********************
;	*** Mes Documents ***
;	*********************

							INVOKE	Memory_Alloc,SIZEOF TV_FOLDERS

							mov		edi,eax
							mov		lpMesDocuments,eax

							mov		_TVis.itemex.lParam,eax

							mov		edx,_hComputer
							mov		(TV_FOLDERS Ptr [eax]).hParent,edx
							mov		(TV_FOLDERS Ptr [eax]).dwType,-1
							mov		(TV_FOLDERS Ptr [eax]).dwIndex,1

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [eax]).szDirectoryName,ADDR szMyDocuments

							mov		_TVis.itemex.pszText,OFFSET szMesDocuments
							mov		_TVis.itemex.iImage,3
							mov		_TVis.itemex.iSelectedImage,3

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

;	******************
;	*** Ma Musique ***
;	******************

							INVOKE	Memory_Alloc,SIZEOF TV_FOLDERS

							mov		edi,eax
							mov		lpMaMusique,eax

							mov		_TVis.itemex.lParam,eax
							mov		(TV_FOLDERS Ptr [eax]).dwIndex,2
							mov		(TV_FOLDERS Ptr [eax]).dwType,-1
							mov		edx,_hComputer
							mov		(TV_FOLDERS Ptr [eax]).hParent,edx

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [eax]).szDirectoryName,ADDR szMyMusique

							mov		_TVis.itemex.pszText,OFFSET szMaMusique
							mov		_TVis.itemex.iImage,6
							mov		_TVis.itemex.iSelectedImage,6

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

;	******************
;	*** Mes Images ***
;	******************

							INVOKE	Memory_Alloc,SIZEOF TV_FOLDERS

							mov		edi,eax
							mov		lpMesImages,eax

							mov		_TVis.itemex.lParam,eax

							mov		edx,_hComputer
							mov		(TV_FOLDERS Ptr [eax]).hParent,edx
							mov		(TV_FOLDERS Ptr [eax]).dwIndex,3
							mov		(TV_FOLDERS Ptr [eax]).dwType,-1

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [eax]).szDirectoryName,ADDR szMyImages

							mov		_TVis.itemex.pszText,OFFSET szMesImages
							mov		_TVis.itemex.iImage,4
							mov		_TVis.itemex.iSelectedImage,4

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

;	******************
;	*** Mes Vidos ***
;	******************

							INVOKE	Memory_Alloc,SIZEOF TV_FOLDERS

							mov		edi,eax
							mov		lpMesVideos,eax

							mov		_TVis.itemex.lParam,eax

							mov		edx,_hComputer
							mov		(TV_FOLDERS Ptr [eax]).hParent,edx
							mov		(TV_FOLDERS Ptr [eax]).dwIndex,4
							mov		(TV_FOLDERS Ptr [eax]).dwType,-1

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [eax]).szDirectoryName,ADDR szMyVideos

							mov		_TVis.itemex.pszText,OFFSET szMesVideos
							mov		_TVis.itemex.iImage,5
							mov		_TVis.itemex.iSelectedImage,5

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax

;	***************************
;	*** Ajouter les disques ***
;	***************************

							INVOKE	SetErrorMode,SEM_FAILCRITICALERRORS

							lea		eax,_szTmp

							mov		_TVis.itemex.pszText,eax
							mov		_TVis.hInsertAfter,TVI_SORT

							mov		eax,_hComputer
							mov		_TVis.hParent,eax

							mov		_TVis.itemex.imask,TVIF_DI_SETITEM or TVIF_PARAM or TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
							mov		_TVis.itemex.state,0
							mov		_TVis.itemex.iIntegral,0
							mov		_TVis.itemex.cChildren,1

							call	GetLogicalDrives

							mov		ecx,eax

							mov		ebx,'A' - 1

@@ :

							test	ecx,ecx
							jz		NoDrive

							mov		eax,ecx

							shr		ecx,1

							push	ecx
							push	ebx

							and		eax,00000001b
							jz		@Next

							add		eax,ebx
							mov		_dwDrive,eax

							INVOKE	wsprintf,_TVis.itemex.pszText,ADDR szFmt_0002,eax

							mov		_TVis.itemex.cchTextMax,eax

							INVOKE	GetDriveType,_TVis.itemex.pszText

							mov		_dwTmp,eax

							xor		edx,edx
							mov		ecx,1

							cmp		eax,DRIVE_UNKNOWN
							cmove	edx,ecx

							mov		ecx,12

							cmp		eax,DRIVE_REMOVABLE				; 12
							cmove	edx,ecx

							mov		ecx,10

							cmp		eax,DRIVE_FIXED					; 10
							cmove	edx,ecx

							mov		ecx,33

							cmp		eax,DRIVE_REMOTE				; 33
							cmove	edx,ecx

							mov		ecx,9

							cmp		eax,DRIVE_CDROM					; 9
							cmove	edx,ecx

							mov		ecx,12

							cmp		eax,DRIVE_RAMDISK				; 12
							cmove	edx,ecx

							mov		_TVis.itemex.iImage,edx
							mov		_TVis.itemex.iSelectedImage,edx

							INVOKE	Memory_Alloc,SIZEOF TV_FOLDERS

							test	eax,eax
							jz		@Next

							mov		edi,eax
							mov		_TVis.itemex.lParam,eax

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName,_TVis.itemex.pszText

							mov		eax,_hComputer
							mov		(TV_FOLDERS Ptr [edi]).hParent,eax

							mov		eax,_dwTmp
							mov		(TV_FOLDERS Ptr [edi]).dwType,eax
							mov		(TV_FOLDERS Ptr [edi]).dwRoot,TRUE

							INVOKE	SendMessage,hTreeView,TVM_INSERTITEM,0,ADDR _TVis

							mov		(TV_FOLDERS Ptr [edi]).hItem,eax
							mov		edx,DWord Ptr _dwDrive

@Next :

							pop		ebx
							pop		ecx

							inc		ebx
							jmp		@B

NoDrive :

							INVOKE	SendMessage,hTreeView,TVM_EXPAND,TVE_EXPAND,_hParent
							INVOKE	SendMessage,hTreeView,TVM_EXPAND,TVE_EXPAND,_hComputer

@Exit :

							ret
Folders_WmCreate			ENDP

;	================================================================================

Folders_WmClose				PROC	USES EBX EDI ESI

							INVOKE	Memory_Free,lpBureau
							INVOKE	Memory_Free,lpPosteDeTravail
							INVOKE	Memory_Free,lpMesDocuments
							INVOKE	Memory_Free,lpMesImages
							INVOKE	Memory_Free,lpMaMusique
							INVOKE	Memory_Free,lpMesVideos

							ret
Folders_WmClose				ENDP

;	================================================================================

Folders_WmSize				PROC	USES EBX EDI ESI,_dwNewWidth:DWord,_dwNewHeight:DWord

							INVOKE	MoveWindow,hTreeView,0,0,_dwNewWidth,_dwNewHeight,TRUE

							ret
Folders_WmSize				ENDP

;	================================================================================

Folders_WmNotify			PROC	USES EBX EDI ESI,_hWnd:HWND,_lpNmHdr:Ptr NMHDR
							LOCAL	lpNmTreeView:Ptr NMTREEVIEW
							LOCAL	_dwIndex:DWord
							LOCAL	_Tvi:TVITEM
							LOCAL	_szTmp[MAX_PATH]:Byte
							LOCAL	_szTmpDir[MAX_PATH]:Byte
							LOCAL	_lParam:LPBYTE
							LOCAL	_Wf:WIN32_FIND_DATA

							mov		ebx,_lpNmHdr

							cmp		(NMHDR Ptr [ebx]).code,TVN_SELCHANGED
							je		@SelChanged

							jmp		@Exit

@SelChanged :

							mov		lpNmTreeView,ebx
							mov		eax,(NMTREEVIEW Ptr [ebx]).itemNew.hItem
							mov		_Tvi.hItem,eax
							mov		_Tvi._mask,TVIF_PARAM or TVIF_TEXT
							lea		eax,_szTmp
							mov		_Tvi.pszText,eax
							mov		_Tvi.cchTextMax,SIZEOF _szTmp
							mov		_Tvi.lParam,NULL

							INVOKE	SendMessage,hTreeView,TVM_GETITEM,0,ADDR _Tvi

							test	eax,eax
							jz		@Exit

							mov		edi,_Tvi.lParam

							test	edi,edi
							jz		@Exit

							mov		eax,edi

							shr		eax,16
							jz		@SubDir

							cmp		(TV_FOLDERS Ptr [edi]).dwRoot,TRUE
							je		@Root

@SubDir :

							cmp		edi,1
							je		@FirstDirectory

;	***********************************************
;	*** Rechercher la racine de cette slection ***
;	***********************************************

							mov		_dwIndex,edi

							INVOKE	lstrcpy,ADDR _szTmpDir,ADDR _szTmp

							INVOKE	SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_CHILD,_Tvi.hItem

							test	eax,eax
							jnz		@Exit

							push	edi
							mov		edi,OFFSET szBuffer
							mov		ecx,(SIZEOF szBuffer) / (SIZEOF DWord)
							xor		eax,eax
							rep		stosd
							mov		edi,OFFSET szResult
							mov		ecx,(SIZEOF szResult) / (SIZEOF DWord)
							rep		stosd
							pop		edi

							mov		_Tvi._mask,TVIF_PARAM or TVIF_TEXT
							mov		_Tvi.lParam,NULL
							lea		eax,_szTmp
							mov		_Tvi.pszText,eax
							mov		_Tvi.cchTextMax,SIZEOF _szTmp

@Loop :

							INVOKE	SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_PARENT,_Tvi.hItem

							mov		_Tvi.hItem,eax

							INVOKE	SendMessage,hTreeView,TVM_GETITEM,0,ADDR _Tvi

							test	eax,eax
							jz		@Exit

							INVOKE	lstrcat,ADDR szBuffer,ADDR _szTmp
							INVOKE	lstrcat,ADDR szBuffer,ADDR szSeparateur

							dec		edi
							jnz		@Loop

;	0x00408E38  6d 61 73 6d 33 32 7c 43 3a 5c 7c 00 00 00 00 00 00  masm32|C:\|......

							mov		esi,OFFSET szBuffer

							INVOKE	StrLen,esi

							mov		edi,eax
							sub		edi,2

							mov		Byte Ptr [esi + eax - 1],0
							add		esi,eax
							sub		esi,2

@LoopPath :

							cmp		Byte Ptr [esi],'|'
							je		@Separator

@EndLoopPath :

							dec		esi

							dec		edi
							jnz		@LoopPath

							INVOKE	lstrcat,ADDR szResult,esi
							INVOKE	lstrcat,ADDR szResult,ADDR szBackSlash
							INVOKE	lstrcat,ADDR szResult,ADDR _szTmpDir

							mov		edi,_Tvi.lParam
							mov		eax,(NMTREEVIEW Ptr [ebx]).itemNew.hItem
							mov		(TV_FOLDERS Ptr [edi]).hThreadParent,eax
							mov		eax,_dwIndex
							inc		eax
							mov		(TV_FOLDERS Ptr [edi]).dwThreadIndex,eax

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName,ADDR szResult

							INVOKE	GetCurrentDirectory,SIZEOF _szTmp,ADDR _szTmp
							INVOKE	SetCurrentDirectory,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName

							test	eax,eax
							jz		@Exit

							INVOKE	FindFirstFile,ADDR szAllFiles,ADDR _Wf

							mov		esi,eax

							INVOKE	SetCurrentDirectory,ADDR _szTmp

							cmp		esi,INVALID_HANDLE_VALUE
							je		@Exit

							INVOKE	FindClose,esi

							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_SELECTED,NULL,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName

							INVOKE	CreateThread,NULL,NULL,ADDR ThreadNextFoldersProc,edi,0,NULL

							push	eax
							push	OFFSET @Finished
							jmp		CloseHandle

@Separator :

							mov		Byte Ptr [esi],0
							mov		eax,esi
							inc		eax

							INVOKE	lstrcat,ADDR szResult,eax

							INVOKE	StrLen,ADDR szResult
							dec		eax

							cmp		Byte Ptr [OFFSET szResult + eax],'\'
							je		@EndLoopPath

							INVOKE	lstrcat,ADDR szResult,ADDR szBackSlash

							jmp		@EndLoopPath

@FirstDirectory :

							INVOKE	SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_CHILD,_Tvi.hItem

							test	eax,eax
							jnz		@Exit

							INVOKE	SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_PARENT,_Tvi.hItem

							mov		_Tvi.hItem,eax
							mov		_Tvi._mask,TVIF_PARAM
							mov		_Tvi.lParam,NULL

							INVOKE	SendMessage,hTreeView,TVM_GETITEM,0,ADDR _Tvi

							test	eax,eax
							jz		@Exit

							mov		edi,_Tvi.lParam
							mov		eax,(NMTREEVIEW Ptr [ebx]).itemNew.hItem
							mov		(TV_FOLDERS Ptr [edi]).hThreadParent,eax

							INVOKE	wsprintf,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName,ADDR szFmt_0001,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName,ADDR _szTmp

							INVOKE	GetCurrentDirectory,SIZEOF _szTmp,ADDR _szTmp
							INVOKE	SetCurrentDirectory,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName

							test	eax,eax
							jz		@Exit

							INVOKE	FindFirstFile,ADDR szAllFiles,ADDR _Wf

							mov		esi,eax

							INVOKE	SetCurrentDirectory,ADDR _szTmp

							cmp		esi,INVALID_HANDLE_VALUE
							je		@Exit

							INVOKE	FindClose,esi

							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_SELECTED,NULL,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName

							INVOKE	CreateThread,NULL,NULL,ADDR ThreadFirstFoldersProc,edi,0,NULL

							push	eax
							push	OFFSET @Finished
							jmp		CloseHandle

;	************************************************
;	*** Ajouter les dossiers lis  cette racine ***
;	************************************************

@Root :

							INVOKE	SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_CHILD,_Tvi.hItem

							test	eax,eax
							jnz		@Exit

							INVOKE	GetCurrentDirectory,SIZEOF _szTmp,ADDR _szTmp
							INVOKE	SetCurrentDirectory,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName

							test	eax,eax
							jz		@Exit

							INVOKE	lstrcpy,ADDR (TV_FOLDERS Ptr [edi]).szThreadDirectoryName,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName
							INVOKE	FindFirstFile,ADDR szAllFiles,ADDR _Wf

							mov		esi,eax

							INVOKE	SetCurrentDirectory,ADDR _szTmp

							cmp		esi,INVALID_HANDLE_VALUE
							je		@Exit

							INVOKE	FindClose,esi

							INVOKE	SendMessage,hWndMain,WM_IVIEW_FOLDER_SELECTED,NULL,ADDR (TV_FOLDERS Ptr [edi]).szDirectoryName

							INVOKE	CreateThread,NULL,NULL,ADDR ThreadFoldersProc,edi,0,NULL

							push	eax
							push	OFFSET @Finished
							jmp		CloseHandle

@Finished :

							mov		eax,TRUE

@Exit :

							ret
Folders_WmNotify			ENDP

;	================================================================================

Folders_WmCommand			PROC	USES EBX EDI ESI
							ret
Folders_WmCommand			ENDP

;	================================================================================

FoldersWndProc				PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

							mov		esi,DWord Ptr hWnd
							mov		edi,DWord Ptr lParam
							mov		ebx,DWord Ptr wParam
							mov		eax,DWord Ptr uMsg

							cmp		eax,WM_PAINT
							jne		@F

								push	OFFSET @Exit
								jmp		Folders_WmPaint

@@ :

							cmp		eax,WM_CREATE
							jne		@F

								push	OFFSET @End
								jmp		Folders_WmCreate

@@ :

							cmp		eax,WM_CLOSE
							jne		@F

								push	OFFSET @End
								jmp		Folders_WmClose

@@ :

							cmp		eax,WM_SIZE
							jne		@F

								mov		eax,edi
								and		eax,0000ffffh
								shr		edi,16

								push	edi
								push	eax
								push	OFFSET @Exit
								jmp		Folders_WmSize

@@ :

							cmp		eax,WM_NOTIFY
							jne		@F

								push	edi					; LPNMHDR
								push	esi
								push	OFFSET @Exit
								jmp		Folders_WmNotify

@@ :

							cmp		eax,WM_COMMAND
							jne		@F

								movzx	eax,Word Ptr wParam + 2
								push	eax
								movzx	eax,Word Ptr wParam
								push	eax
								push	OFFSET @End
								jmp		Folders_WmCommand

@@ :

							push	edi
							push	ebx
							push	eax
							push	esi
							push	OFFSET @End
							jmp		DefWindowProc							

@Exit :

							xor		eax,eax

@End :

							ret
FoldersWndProc				ENDP

;	================================================================================

Folders_Create :

							INVOKE	CreateWindowEx,WS_EX_CLIENTEDGE or WS_EX_WINDOWEDGE or WS_EX_STATICEDGE or WS_EX_TOOLWINDOW,\
									ADDR szFoldersClass,ADDR szFoldersName,WS_CAPTION or WS_CHILD or WS_VISIBLE,\
									rcFolders.left,rcFolders.top,rcFolders.right,rcFolders.bottom,\
									esi,1907h,hInstance,NULL

							push	eax

							push	eax

							push	SW_SHOW
							push	eax
							call	ShowWindow
							call	UpdateWindow

							pop		eax

							ret

;	================================================================================
