;	================================================================================
							.Code
;	================================================================================


							ALIGN	4

;	================================================================================

Preview_WmPaint			PROC	USES EBX EDI ESI
							LOCAL	_Ps:PAINTSTRUCT
							LOCAL	_hDC:HDC

							lea		eax,_Ps

							push	eax
							push	esi

							INVOKE	BeginPaint,esi,eax 

							mov		_hDC,eax

@Exit :

							call	EndPaint

							ret
Preview_WmPaint			ENDP

;	================================================================================

Preview_WmCreate			PROC	USES EBX EDI ESI
							ret
Preview_WmCreate			ENDP

;	================================================================================

Preview_WmClose			PROC	USES EBX EDI ESI
							ret
Preview_WmClose			ENDP

;	================================================================================

Preview_WmSize			PROC	USES EBX EDI ESI
							ret
Preview_WmSize			ENDP

;	================================================================================

Preview_WmNotify			PROC	USES EBX EDI ESI
							ret
Preview_WmNotify			ENDP

;	================================================================================

Preview_WmCommand		PROC	USES EBX EDI ESI
							ret
Preview_WmCommand		ENDP

;	================================================================================

PreviewWndProc			PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

							mov		esi,DWord Ptr hWnd
							mov		edi,DWord Ptr lParam
							mov		ebx,DWord Ptr wParam
							mov		eax,DWord Ptr uMsg

							cmp		eax,WM_PAINT
							jne		@F

								push	OFFSET @Exit
								jmp		Preview_WmPaint

@@ :

							cmp		eax,WM_CREATE
							jne		@F

								push	OFFSET @End
								jmp		Preview_WmCreate

@@ :

							cmp		eax,WM_CLOSE
							jne		@F

								push	OFFSET @End
								jmp		Preview_WmClose

@@ :

							cmp		eax,WM_SIZE
							jne		@F

								push	OFFSET @Exit
								jmp		Preview_WmSize

@@ :

							cmp		eax,WM_NOTIFY
							jne		@F

								push	OFFSET @Exit
								jmp		Preview_WmNotify

@@ :

							cmp		eax,WM_COMMAND
							jne		@F

								movzx	eax,Word Ptr wParam + 2
								push	eax
								movzx	eax,Word Ptr wParam
								push	eax
								push	OFFSET @End
								jmp		Preview_WmCommand

@@ :

							push	edi
							push	ebx
							push	eax
							push	esi
							push	OFFSET @End
							jmp		DefWindowProc							

@Exit :

							xor		eax,eax

@End :

							ret
PreviewWndProc			ENDP

;	================================================================================

Preview_Create :

							INVOKE	CreateWindowEx,WS_EX_CLIENTEDGE or WS_EX_WINDOWEDGE or WS_EX_STATICEDGE or WS_EX_TOOLWINDOW,\
									ADDR szPreviewClass,ADDR szPreviewName,WS_CAPTION or WS_CHILD or WS_VISIBLE,\
									rcPreview.left,rcPreview.top,rcPreview.right,rcPreview.bottom,\
									esi,1903h,hInstance,NULL

							push	eax

							push	eax

							push	SW_SHOW
							push	eax
							call	ShowWindow
							call	UpdateWindow

							pop		eax

							ret

;	================================================================================
