OFN_FORCESHOWHIDDEN				=	10000000h
OFN_ENABLESIZING				=	00800000h

ASSOCF_INIT_NOREMAPCLSID		= 00000001h		; do not remap clsids to progids
ASSOCF_INIT_BYEXENAME			= 00000002h		; executable is being passed in
ASSOCF_OPEN_BYEXENAME			= 00000002h		; executable is being passed in
ASSOCF_INIT_DEFAULTTOSTAR		= 00000004h		; treat "*" as the BaseClass
ASSOCF_INIT_DEFAULTTOFOLDER		= 00000008h		; treat "Folder" as the BaseClass
ASSOCF_NOUSERSETTINGS			= 00000010h		; dont use HKCU
ASSOCF_NOTRUNCATE				= 00000020h		; dont truncate the return string
ASSOCF_VERIFY					= 00000040h		; verify data is accurate (DISK HITS)
ASSOCF_REMAPRUNDLL				= 00000080h		; actually gets info about rundlls target if applicable
ASSOCF_NOFIXUPS					= 00000100h		; attempt to fix errors if found
ASSOCF_IGNOREBASECLASS			= 00000200h		; dont recurse into the baseclass

ASSOCSTR_COMMAND				=	1	; shell\verb\command string
ASSOCSTR_EXECUTABLE				=	2	; the executable part of command string
ASSOCSTR_FRIENDLYDOCNAME		=	3	; friendly name of the document type
ASSOCSTR_FRIENDLYAPPNAME		=	4	; friendly name of executable
ASSOCSTR_NOOPEN					=	5	; noopen value
ASSOCSTR_SHELLNEWVALUE			=	6	; query values under the shellnew key
ASSOCSTR_DDECOMMAND				=	7	; template for DDE commands
ASSOCSTR_DDEIFEXEC				=	8	; DDECOMMAND to use if just create a process
ASSOCSTR_DDEAPPLICATION			=	9	; Application name in DDE broadcast
ASSOCSTR_DDETOPIC				=	10	; Topic Name in DDE broadcast
ASSOCSTR_INFOTIP				=	11	; info tip for an item, or list of properties to create info tip from
ASSOCSTR_QUICKTIP				=	12	; same as ASSOCSTR_INFOTIP, except, this list contains only quickly retrievable properties
ASSOCSTR_TILEINFO				=	13	; similar to ASSOCSTR_INFOTIP - lists important properties for tileview
ASSOCSTR_CONTENTTYPE			=	14	; MIME Content type
ASSOCSTR_DEFAULTICON			=	15	; Default icon source
ASSOCSTR_SHELLEXTENSION			=	16	; Guid string pointing to the Shellex\Shellextensionhandler value.
ASSOCSTR_MAX					=	17	; last item in enum...

MOVEFILE_REPLACE_EXISTING		=	00000001h
MOVEFILE_COPY_ALLOWED			=	00000002h
MOVEFILE_DELAY_UNTIL_REBOOT		=	00000004h
MOVEFILE_WRITE_THROUGH			=	00000008h
MOVEFILE_CREATE_HARDLINK		=	00000010h
MOVEFILE_FAIL_IF_NOT_TRACKABLE	=	00000020h

CSIDL_MYPICTURES				=	39

DRIVE_UNKNOWN					=	0
DRIVE_NO_ROOT_DIR				=	1
DRIVE_REMOVABLE					=	2
DRIVE_FIXED						=	3
DRIVE_REMOTE					=	4
DRIVE_CDROM						=	5
DRIVE_RAMDISK					=	6

HIMETRIC_INCH					=	2540

IMAGE_VERTICALE					=	1
IMAGE_HORIZONTALE				=	2

DATA_IMAGES						=	1
DATA_UNKNOWN					=	-1

BEGIN_FOLDER					=	1
ADD_FOLDER						=	2
ADD_FILE						=	3
END_FOLDER						=	4
IMAGE_SELECTED					=	5
IMAGE_ORIGINALE					=	6
IMAGE_EFFECTS					=	7

TYPE_DOSSIER					=	1
TYPE_FICHIER					=	2

COULEUR_NOIR					=	1
COULEUR_BLANC					=	2
COULEUR_RGB						=	3
COULEUR_BLEU					=	4
COULEUR_VERT					=	5
COULEUR_ROUGE					=	6
COULEUR_CYAN					=	7
COULEUR_MAGENTA					=	8
COULEUR_JAUNE					=	9

OP_AND							=	0
OP_OR							=	1
OP_XOR							=	2
OP_MIN							=	3
OP_MAX							=	4
OP_AVG							=	5

ROTATION_TOP					=	0
ROTATION_RIGHT					=	1
ROTATION_BOTTOM					=	2
ROTATION_LEFT					=	3

VIEW_MODE_LISTE					=	1
VIEW_MODE_DETAILS				=	2
VIEW_MODE_MINIATURES			=	3
VIEW_MODE_PELLICULE				=	4

CORRECTIF_GAMMA					=	0FF000000h

OP_IGNORER						=	1
OP_INVERSER						=	2
OP_NOIR							=	3
OP_ROUGE						=	4
OP_VERT							=	5
OP_BLEU							=	6
OP_BLANC						=	7

SPLITTER_WIDTH					=	8
SPLITTER_HEIGHT					=	8

TV_FOLDERS					STRUCT
	dwIndex					DWord				?
	dwThreadIndex			DWord				?
	dwType					DWord				?
	dwRoot					DWord				?
	dwNumberOfChildren		DWord				?
	dwNumberOfFiles			DWord				?
	hParent					HTREEITEM			?
	hThreadParent			HTREEITEM			?
	hItem					HTREEITEM			?
	szDirectoryName			Byte				MAX_PATH dup(?)
	szThreadDirectoryName	Byte				MAX_PATH dup(?)
TV_FOLDERS					ENDS

LPTV_FOLDERS	TYPEDEF	PTR TV_FOLDERS

TRANCHES_OP					STRUCT
	dwIndex					DWord				?		; N de la tranche 
	dwOperator				DWord				?		; Oprateur
	dwInvert				DWord				?		; Inverser le rsultat
	dwGamma					DWord				?		; Coefficient Gamma
TRANCHES_OP					ENDS

LPTRANCHES_OP	TYPEDEF	PTR TRANCHES_OP

PICTURE_TRANCHES			STRUCT
	dwStructureSize			DWord				?
	dwGamma_T1				DWord				?
	dwGamma_T2				DWord				?
	dwGamma_T3				DWord				?
	dwGamma_Rgb				DWord				?
PICTURE_TRANCHES			ENDS

LPPICTURE_TRANCHES	TYPEDEF	PTR PICTURE_TRANCHES

IMAGE_INFOS					STRUCT
	dwStructureSize			DWord				?
	dwTotalDatasSize		DWord				?
	Image					BITMAPINFOHEADER	<>
	dImageRatio				QWord				?
	dwImageSens				DWord				?			; Sens de l'image
	dwImageData				DWord				?
	dwImageBitsOffset		DWord				?
	lpImageBits				LPBYTE				?
IMAGE_INFOS					ENDS

LPPICTURE_INFOS	TYPEDEF	PTR PICTURE_INFOS

WORK_EFFECTS				STRUCT
	dwInverserResultat		DWord				?
	dwDosageRouge			DWord				?
	dwDosageVert			DWord				?
	dwDosageBleu			DWord				?
	dwDosageResultat		DWord				?
	dwDefinitionBlanc		DWord				?
	dwDefinitionNoir		DWord				?
WORK_EFFECTS				ENDS

LPWORK_EFFECTS	TYPEDEF	PTR WORK_EFFECTS

PICTURE_PROJECT				STRUCT
	dwSignature				DWord				?
	dwVersion				DWord				?

	dwStructureSize			DWord				?
	dwTotalDataSize			DWord				?

	dwProjectModified		DWord				?			; Projet modifi si cette variable vaut 1

	stCreationDate			SYSTEMTIME			<>
	stLastModifDate			SYSTEMTIME			<>

	Fichier_Datas			WIN32_FIND_DATA		<>
	Picture					IMAGE_INFOS			<>
	Tranches				PICTURE_TRANCHES	<>
	Work					WORK_EFFECTS		<>

	dwPictureDatasOffset	DWord				?
	dwPictureWorkOffset		DWord				?
	dwPictureTempOffset		DWord				?					; Stockage temporaire pour travail sur les tranches
	szProjectFullFileName	Byte				MAX_PATH dup(?)
	szProjectFileTitle		Byte				MAX_PATH dup(?)
	szProjectDirectory		Byte				MAX_PATH dup(?)
	szWorkFileFullFileName	Byte				MAX_PATH dup(?)
	szWorkFileFileTitle		Byte				MAX_PATH dup(?)
	szWorkFileDirectory		Byte				MAX_PATH dup(?)
PICTURE_PROJECT				ENDS

LPPICTURE_PROJECT	TYPEDEF	PTR PICTURE_PROJECT
