;	================================================================================
							.Code
;	================================================================================


							ALIGN	4

;	================================================================================

CreateStatusBar				PROC	USES EBX EDI ESI
							LOCAL	sbParts[8] :DWORD

							INVOKE	CreateStatusWindow,WS_CHILD or WS_VISIBLE or SBS_SIZEGRIP,NULL,esi,200

							mov		hStatusBar,eax

							; -------------------------------------
							; sbParts is a DWORD array of 8 members
							; -------------------------------------

							mov [sbParts +  0], 450
							mov [sbParts +  4], 700
							mov [sbParts +  8], 900
							mov [sbParts + 12], -1

							INVOKE	SendMessage,hStatusBar,SB_SETPARTS,4,ADDR sbParts

							ret
CreateStatusBar				ENDP

;	================================================================================

Main_WmFolderFound			PROC	USES EBX EDI ESI,__lpWf:Ptr WIN32_FIND_DATA,__lpszDirectoryName:LPSTR

							mov		edi,MAX_PLUGINS
							mov		esi,OFFSET hPlugins

@Loop :

							mov		eax,DWord Ptr [esi]

							test	eax,eax
							jz		@NextLoop

							push	edi
							push	esi

							INVOKE	SendMessage,eax,WM_IVIEW_FOLDER_FOUND,__lpWf,__lpszDirectoryName

							pop		esi
							pop		edi

@NextLoop :

							add		esi,SIZEOF DWord
							dec		edi
							jnz		@Loop

							push	__lpszDirectoryName
							push	__lpWf
							push	WM_IVIEW_FOLDER_FOUND
							push	hThumbnails
							push	OFFSET @Exit
							jmp		SendMessage

@Exit :

							ret
Main_WmFolderFound			ENDP

;	================================================================================

Main_WmFolderAdded			PROC	USES EBX EDI ESI,__hTreeItem:HTREEITEM

							mov		edi,MAX_PLUGINS
							mov		esi,OFFSET hPlugins

@Loop :

							mov		eax,DWord Ptr [esi]

							test	eax,eax
							jz		@NextLoop

							push	edi
							push	esi

							INVOKE	SendMessage,eax,WM_IVIEW_FOLDER_ADDED,__hTreeItem,NULL

							pop		esi
							pop		edi

@NextLoop :

							add		esi,SIZEOF DWord
							dec		edi
							jnz		@Loop

							push	NULL
							push	__hTreeItem
							push	WM_IVIEW_FOLDER_ADDED
							push	hThumbnails
							push	OFFSET @Exit
							jmp		SendMessage

@Exit :

							ret
Main_WmFolderAdded			ENDP

;	================================================================================

Main_WmFolderSelected		PROC	USES EBX EDI ESI,__lpszDirectoryName:LPSTR

							mov		edi,MAX_PLUGINS
							mov		esi,OFFSET hPlugins

@Loop :

							mov		eax,DWord Ptr [esi]

							test	eax,eax
							jz		@NextLoop

							push	edi
							push	esi

							INVOKE	SendMessage,eax,WM_IVIEW_FOLDER_SELECTED,NULL,__lpszDirectoryName

							pop		esi
							pop		edi

@NextLoop :

							add		esi,SIZEOF DWord
							dec		edi
							jnz		@Loop

							push	__lpszDirectoryName
							push	NULL
							push	WM_IVIEW_FOLDER_SELECTED
							push	hThumbnails
							push	OFFSET @Exit
							jmp		SendMessage

@Exit :

							ret
Main_WmFolderSelected		ENDP

;	================================================================================

Main_WmCreate				PROC	USES EBX EDI ESI
							LOCAL	_rc:RECT
							LOCAL	_rcStatusBar:RECT
							LOCAL	_rcToolBar:RECT
							LOCAL	_dwY:DWord

							INVOKE	CreateFont,12,0,0,0,FW_ULTRALIGHT,0,0,0,ANSI_CHARSET,OUT_TT_ONLY_PRECIS,CLIP_DEFAULT_PRECIS,CLEARTYPE_QUALITY,VARIABLE_PITCH or FF_DONTCARE,ADDR szTahoma

							mov		hMainFont,eax

							INVOKE	SendMessage,esi,WM_SETFONT,eax,TRUE

							call	CreateToolBar
							call	CreateStatusBar

							INVOKE	GetWindowRect,hToolBar,ADDR _rcToolBar
							INVOKE	GetWindowRect,hStatusBar,ADDR _rcStatusBar

							mov		eax,DWord Ptr _rcToolBar.bottom
							sub		eax,DWord Ptr _rcToolBar.top
							mov		DWord Ptr _dwY,eax
							mov		edx,eax

							mov		eax,DWord Ptr _rcStatusBar.bottom
							sub		eax,DWord Ptr _rcStatusBar.top
							add		eax,edx
							push	eax

							lea		edi,_rc

							INVOKE	GetClientRect,esi,edi

							pop		eax
							sub		DWord Ptr (RECT Ptr [edi]).bottom,eax
							mov		eax,DWord Ptr _dwY
							mov		DWord Ptr (RECT Ptr [edi]).top,eax

							INVOKE	Workspace_Create,edi
							mov		hWorkspace,eax

							ret
Main_WmCreate				ENDP

;	================================================================================

Main_WmClose				PROC	USES EBX EDI ESI

							INVOKE	DeleteObject,hMainFont
							INVOKE	DeleteObject,hBmpToolBar
							INVOKE	DeleteObject,hImageList

							INVOKE	DestroyWindow,esi

							xor		eax,eax
							ret
Main_WmClose				ENDP

;	================================================================================

Main_WmSize					PROC	USES EBX EDI ESI
							ret
Main_WmSize					ENDP

;	================================================================================

Main_WmNotify				PROC	USES EBX EDI ESI
							ret
Main_WmNotify				ENDP

;	================================================================================

Main_WmCommand				PROC	USES EBX EDI ESI
							ret
Main_WmCommand				ENDP

;	================================================================================

MainWndProc					PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

							mov		esi,DWord Ptr hWnd
							mov		edi,DWord Ptr lParam
							mov		ebx,DWord Ptr wParam
							mov		eax,DWord Ptr uMsg

							cmp		eax,WM_DESTROY
							jne		@F

								push	NULL
								push	OFFSET @Exit
								jmp		PostQuitMessage

@@ :

							cmp		eax,WM_IVIEW_FOLDER_FOUND
							jne		@F

								push	edi
								push	ebx
								push	OFFSET @Exit
								jmp		Main_WmFolderFound

@@ :

							cmp		eax,WM_IVIEW_FOLDER_ADDED
							jne		@F

								push	ebx								; hTreeItem
								push	OFFSET @Exit
								jmp		Main_WmFolderAdded

@@ :

							cmp		eax,WM_IVIEW_FOLDER_SELECTED
							jne		@F

								push	edi
								push	OFFSET @Exit
								jmp		Main_WmFolderSelected

@@ :

							cmp		eax,WM_CREATE
							jne		@F

								push	OFFSET @Exit
								jmp		Main_WmCreate

@@ :

							cmp		eax,WM_CLOSE
							jne		@F

								push	OFFSET @End
								jmp		Main_WmClose

@@ :

							cmp		eax,WM_SIZE
							jne		@F

								push	OFFSET @Exit
								jmp		Main_WmSize

@@ :

							cmp		eax,WM_NOTIFY
							jne		@F

								push	OFFSET @Exit
								jmp		Main_WmNotify

@@ :

							cmp		eax,WM_COMMAND
							jne		@F

								movzx	eax,Word Ptr wParam + 2
								push	eax
								movzx	eax,Word Ptr wParam
								push	eax
								push	OFFSET @End
								jmp		Main_WmCommand

@@ :

							push	edi
							push	ebx
							push	eax
							push	esi
							push	OFFSET @End
							jmp		DefWindowProc							

@Exit :

							xor		eax,eax

@End :

							ret
MainWndProc					ENDP

;	================================================================================
