      ; ---------------------------
      ; macros for creating toolbar
      ; ---------------------------

      TBextraData MACRO
        mov tbb.fsState,   TBSTATE_ENABLED
        mov tbb.dwData,    -1
        mov tbb.iString,   0
      ENDM

      ; ------------------------------

      TBbutton MACRO bID, cID, cString,cData
        mov tbb.iBitmap,   bID  ;; button  ID number
        mov tbb.idCommand, cID  ;; command ID number
        mov tbb.fsStyle,   TBSTYLE_BUTTON or BTNS_AUTOSIZE
        mov	tbb.dwData,cData	;; Indiquer que le bouton est affich et son indice
        mov tbb.iString,NULL
        INVOKE SendMessage,hToolBar,TB_ADDBUTTONS,1,ADDR tbb
      ENDM

      ; ------------------------------

      TBbutton2 MACRO bID, cID, cHandle,cData
        mov tbb.iBitmap,   bID  ;; button  ID number
        mov tbb.idCommand, cID  ;; command ID number
        mov tbb.fsStyle,   TBSTYLE_BUTTON or BTNS_AUTOSIZE
        mov	tbb.dwData,cData	;; Indiquer que le bouton est affich et son indice
        mov tbb.iString,NULL
        INVOKE SendMessage,cHandle,TB_ADDBUTTONS,1,ADDR tbb
      ENDM

      ; ------------------------------

      TBblank MACRO
        mov tbb.iBitmap,   0
        mov tbb.idCommand, 0
        mov tbb.fsStyle,   TBSTYLE_SEP
        INVOKE SendMessage,hToolBar,TB_ADDBUTTONS,1,ADDR tbb
      ENDM

; --------------------------------------------------------------------------------------------------------------------------------------

    SetBmpColor PROTO :DWORD

; --------------------------------------------------------------------------------------------------------------------------------------
							.Code
; --------------------------------------------------------------------------------------------------------------------------------------

							ALIGN	4

; --------------------------------------------------------------------------------------------------------------------------------------

CreateToolBar				PROC
							LOCAL	tbab:TBADDBITMAP
							LOCAL	tbb:TBBUTTON
							LOCAL	_rc:RECT

							INVOKE	GetClientRect,esi,ADDR _rc

							INVOKE	CreateWindowEx,0,ADDR szToolBarClass,ADDR szNullString,
									WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or TBSTYLE_ALTDRAG or CCS_ADJUSTABLE or TBSTYLE_WRAPABLE,
									0,0,_rc.right,80,esi,NULL,hInstance,NULL

							mov		DWord Ptr hToolBar,eax

							INVOKE	SendMessage,hToolBar,TB_BUTTONSTRUCTSIZE,SIZEOF TBBUTTON,0

							INVOKE	SendMessage,hToolBar,TB_GETTOOLTIPS,0,0
							mov		DWord Ptr [hToolTips],eax

							INVOKE	SendMessage,eax,TTM_SETDELAYTIME,TTDT_AUTOMATIC,0
							INVOKE	SendMessage,hToolBar,TB_SETBITMAPSIZE,0,00180018h

							INVOKE	LoadBitmap,hInstance,IDB_BARREOUTILS

							mov		DWord Ptr [hBmpToolBar],eax
							mov		DWord Ptr tbab.nID,eax
							mov		DWord Ptr tbab.hInst,0

							INVOKE	SetBmpColor,eax

							INVOKE	SendMessage,hToolBar,TB_ADDBITMAP,7,ADDR tbab
							INVOKE	SendMessage,hToolBar,TB_SETBUTTONSIZE,0,00200020h

							TBextraData										; additional data for TBBUTTON structure

							TBbutton2	13,	IDM_FILE_RENAME,hToolBar,13		; Sauver Sous 
							TBbutton2	19,	IDM_FILE_PRINT,hToolBar,19		; Print 
							TBbutton2	17,	IDM_TAILLE_ECRAN,hToolBar,17	; Chercher
							TBbutton2	 6,	IDM_CLIPBOARD_COPY,hToolBar,6	; Copy
							TBbutton2	10,	IDM_FILE_DELETE,hToolBar,10		; Delete
							TBbutton2	44,	IDM_FILE_MOVETO,hToolBar,44		; Dplacer dans
							TBbutton2	45,	IDM_FILE_COPYTO,hToolBar,45		; Copier dans

							ret
CreateToolBar				ENDP

; --------------------------------------------------------------------------------------------------------------------------------------

SetBmpColor	PROC	hBitmap:HBITMAP
			LOCAL hDC       :HDC
			LOCAL hBrush    :HBRUSH
			LOCAL hOldBmp   :HBITMAP
			LOCAL hReturn   :DWORD
			LOCAL hOldBrush :HBRUSH

			INVOKE CreateCompatibleDC,NULL
			mov hDC,eax

			INVOKE SelectObject,eax,hBitmap
			mov hOldBmp,eax

			INVOKE GetSysColor,COLOR_BTNFACE
			INVOKE CreateSolidBrush,eax
			mov hBrush,eax

			INVOKE SelectObject,hDC,hBrush
			mov hOldBrush,eax

			INVOKE GetPixel,hDC,1,1
			INVOKE ExtFloodFill,hDC,1,1,eax,FLOODFILLSURFACE

			INVOKE SelectObject,hDC,hOldBrush
			INVOKE DeleteObject,hBrush

			INVOKE SelectObject,hDC,hBitmap
			mov hReturn,eax
			INVOKE DeleteDC,hDC

			mov eax,hReturn
			ret
SetBmpColor	ENDP

; --------------------------------------------------------------------------------------------------------------------------------------
