						.686
						.Model flat,stdcall
						Option casemap:none

;	================================================================================

						Include I-View.inc

;	================================================================================

						Include	I-View - Datas.asm

;	================================================================================

						Include	PhR - Memory.asm
						Include	PhR - Files.asm
						Include	PhR - GDI Plus.asm

;	================================================================================

						Include	Images Utilities.asm

;	================================================================================

						Include	I-View - Project.asm

						Include	I-View - BH1.asm
						Include	I-View - BH2.asm

						Include	I-View - BV1.asm

						Include	I-View - Effects.asm
						Include	I-View - Folders.asm
						Include	I-View - Preview.asm
						Include	I-View - Thumbnails.asm

;	================================================================================

						Include	I-View - Workspace.asm
						Include	I-View - Toolbar.asm
						Include	I-View - Main.asm

;	================================================================================

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

;	================================================================================
							.Code
;	================================================================================


							ALIGN	4

;	================================================================================

Start :

						INVOKE	GetModuleHandle, NULL
						mov		hInstance,eax

						INVOKE	GDIPLUS_Init

						INVOKE	SystemParametersInfo,SPI_GETWORKAREA,NULL,ADDR rcWorkArea,0

						mov		eax,rcWorkArea.left
						sub		rcWorkArea.right,eax

						mov		eax,DWord Ptr rcWorkArea.top
						sub		DWord Ptr rcWorkArea.bottom,eax

						INVOKE	GetCommandLine
						mov    lpszCommandLine,eax

						mov		DWord Ptr Icc.dwSize,SIZEOF INITCOMMONCONTROLSEX
						mov		Icc.dwICC,ICC_ANIMATE_CLASS or ICC_BAR_CLASSES or ICC_COOL_CLASSES or ICC_DATE_CLASSES or ICC_LISTVIEW_CLASSES or ICC_PROGRESS_CLASS or ICC_TAB_CLASSES or ICC_TREEVIEW_CLASSES or ICC_UPDOWN_CLASS

						push	OFFSET Icc
						call	InitCommonControlsEx

						test	eax,eax
						jz		Start_Exit

						INVOKE WinMain, hInstance,NULL,lpszCommandLine,SW_SHOWDEFAULT

Start_Exit :

						INVOKE	GDIPlus_Exit

						INVOKE	ExitProcess,eax

;	================================================================================

WinMain					PROC	hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
						LOCAL	wc:WNDCLASSEX

						lea		edi,wc

						mov		(WNDCLASSEX Ptr [edi]).cbSize,SIZEOF WNDCLASSEX
						mov		(WNDCLASSEX Ptr [edi]).style,CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS or CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW or CS_DROPSHADOW
						mov		(WNDCLASSEX Ptr [edi]).lpfnWndProc,OFFSET MainWndProc
						mov		(WNDCLASSEX Ptr [edi]).cbClsExtra,NULL
						mov		(WNDCLASSEX Ptr [edi]).cbWndExtra,SIZEOF DWord

						push	hInstance
						pop		(WNDCLASSEX Ptr [edi]).hInstance

						mov		(WNDCLASSEX Ptr [edi]).hbrBackground,COLOR_WINDOW + 1
						mov		(WNDCLASSEX Ptr [edi]).lpszMenuName,IDM_MENU
						mov		(WNDCLASSEX Ptr [edi]).lpszClassName,OFFSET szClassName

						INVOKE	LoadIcon,hInstance,IDI_DELETE

						mov		(WNDCLASSEX Ptr [edi]).hIcon,eax
						mov		(WNDCLASSEX Ptr [edi]).hIconSm,eax

						INVOKE	LoadCursor,NULL,IDC_ARROW

						mov		(WNDCLASSEX Ptr [edi]).hCursor,eax

						INVOKE	RegisterClassEx,edi

						test	eax,eax
						jz		WinMain_Exit

						xor		eax,eax

						mov		(WNDCLASSEX Ptr [edi]).lpszMenuName,eax
						mov		(WNDCLASSEX Ptr [edi]).hIcon,eax
						mov		(WNDCLASSEX Ptr [edi]).hIconSm,eax

						mov		(WNDCLASSEX Ptr [edi]).hbrBackground,COLOR_APPWORKSPACE + 1

;	******************************************
;	*** Fentre contenant tous les enfants ***
;	******************************************

						mov		(WNDCLASSEX Ptr [edi]).lpfnWndProc,OFFSET WorkspaceWndProc
						mov		(WNDCLASSEX Ptr [edi]).lpszClassName,OFFSET szWorkspaceClass

						INVOKE	RegisterClassEx,edi

;	***************************************
;	*** Fentre des barres Horizontales ***
;	***************************************

						INVOKE	LoadCursor,NULL,IDC_SIZENS

						mov		(WNDCLASSEX Ptr [edi]).hCursor,eax

						mov		(WNDCLASSEX Ptr [edi]).hbrBackground,COLOR_ACTIVECAPTION + 1

						mov		(WNDCLASSEX Ptr [edi]).lpfnWndProc,OFFSET BH1WndProc
						mov		(WNDCLASSEX Ptr [edi]).lpszClassName,OFFSET szBH1Class

						INVOKE	RegisterClassEx,edi

						mov		(WNDCLASSEX Ptr [edi]).lpfnWndProc,OFFSET BH2WndProc
						mov		(WNDCLASSEX Ptr [edi]).lpszClassName,OFFSET szBH2Class

						INVOKE	RegisterClassEx,edi

;	*************************************
;	*** Fentre des barres Verticales ***
;	*************************************

						INVOKE	LoadCursor,NULL,IDC_SIZEWE

						mov		(WNDCLASSEX Ptr [edi]).hCursor,eax

						mov		(WNDCLASSEX Ptr [edi]).lpfnWndProc,OFFSET BV1WndProc
						mov		(WNDCLASSEX Ptr [edi]).lpszClassName,OFFSET szBV1Class

						INVOKE	RegisterClassEx,edi

;	****************************************
;	*** Fentre du TreeView des dossiers ***
;	****************************************

						INVOKE	LoadCursor,NULL,IDC_ARROW

						mov		(WNDCLASSEX Ptr [edi]).hCursor,eax

						mov		(WNDCLASSEX Ptr [edi]).hbrBackground,COLOR_SCROLLBAR + 1

						mov		(WNDCLASSEX Ptr [edi]).lpfnWndProc,OFFSET FoldersWndProc
						mov		(WNDCLASSEX Ptr [edi]).lpszClassName,OFFSET szFoldersClass

						INVOKE	RegisterClassEx,edi

;	******************************************
;	*** Fentre d'affichage des miniatures ***
;	******************************************

						mov		(WNDCLASSEX Ptr [edi]).lpfnWndProc,OFFSET ThumbnailsWndProc
						mov		(WNDCLASSEX Ptr [edi]).lpszClassName,OFFSET szThumbnailsClass

						INVOKE	RegisterClassEx,edi

;	******************************************************************************
;	*** Fentre de visualisation de l'image en fonction de l'effet slectionn ***
;	******************************************************************************

						mov		(WNDCLASSEX Ptr [edi]).lpfnWndProc,OFFSET PreviewWndProc
						mov		(WNDCLASSEX Ptr [edi]).lpszClassName,OFFSET szPreviewClass

						INVOKE	RegisterClassEx,edi

;	**********************************************************
;	*** Fentre contenant la combo de slection des effets ***
;	**********************************************************

						mov		(WNDCLASSEX Ptr [edi]).lpfnWndProc,OFFSET EffectsWndProc
						mov		(WNDCLASSEX Ptr [edi]).lpszClassName,OFFSET szEffectsClass

						INVOKE	RegisterClassEx,edi

						INVOKE	CreateWindowEx,WS_EX_APPWINDOW or WS_EX_OVERLAPPEDWINDOW or WS_EX_STATICEDGE,\
								ADDR szClassName,ADDR szAppName,WS_OVERLAPPEDWINDOW,\
								rcWorkArea.left,rcWorkArea.top,rcWorkArea.right,rcWorkArea.bottom,NULL,NULL,hInst,NULL

						test	eax,eax
						jz		WinMain_Exit

						mov		hWndMain,eax

						push	eax

						push	SW_SHOWNORMAL
						push	eax
						call	ShowWindow

						call	UpdateWindow

;	**************************************
;	*** Boucle de gestion des messages ***
;	**************************************

WinMain_Loop :

						push	0
						push	0
						push	NULL
						push	OFFSET Msg
						call	GetMessage					; Rcupration du message

;		===============================================================
;		=== Si GetMessage renvoie la valeur '0' => Fin du programme ===
;		===============================================================

						test	eax,eax						; Fin du programme ?
						jz		WinMain_Exit				; Oui

						INVOKE	IsDialogMessage,hActive,ADDR Msg

						test	eax,eax

						jnz		WinMain_Loop

;		======================================
;		=== Traitement normal des messages ===
;		======================================

						push	OFFSET Msg
						push	OFFSET WinMain_Loop
						push	OFFSET Msg
						push	OFFSET DispatchMessage
						jmp		TranslateMessage 

WinMain_Exit :

						mov		eax,DWord Ptr Msg.wParam
						ret
WinMain					ENDP

;	================================================================================
						END	Start
;	================================================================================
